-- 
-- 1. Übung zur Geometrieverwaltung
-- erleichtertes Management ab der Version 2.0
--
----------------------------------------------------------------------
-- Erläuterung


#  Aufruf auf der Konsole
-- Aufruf als SQL 
----------------------------------------------------------------------
 
----------------------------------------------------------------------
-- 1. Starten Sie die Datenbank PostgreSQL 9.1
----------------------------------------------------------------------

# Liste der Datenbanken
psql -U user -p 5432 -l

# Anmeldung
psql -U user -p 5432 dbname


--
-- Ausgabe der PostGIS Version und Version der Bibliotheken
--
SELECT postgis_full_version();

postgis_full_version
------------------------------
"POSTGIS="2.0.0alpha7SVN" GEOS="3.3.2-CAPI-1.7.2" PROJ="Rel. 4.7.1, 23 September 2009" LIBXML="2.7.8" USE_STATS";"PostgreSQL 9.1.2 on i686-pc-linux-gnu, compiled by gcc (Ubuntu/Linaro 4.5.2-8ubuntu4) 4.5.2, 32-bit"


----------------------------------------------------------------------
-- 1.1 Erzeugen Sie eine Datenbank über CREATE EXTENSION
----------------------------------------------------------------------
* Erzeugen Sie eine Datenbank und laden Sie PostGIS über CREATE EXTENSION
* Wo befinden sich die Extensions im Dateisystem?
* Schauen Sie sich den Inhalt der Datei postgis.control an?

# Datenbank ohne PostGIS erzeugen
createdb -U user -p 5432 fossgis

# Anmeldung an der Datenbank
psql -U user -p 5432 fossgis


-- Laden der Extension postgis
-- installiert PostGIS geometry, geography, raster, spatial_ref_sys 
-- und alle Funktionen und Kommentare 
CREATE EXTENSION postgis;

# Anzeige der postgis.control
cd /usr/share/postgresql/9.1/extension/

ls -1 postgis*
postgis--2.0.0alpha1--2.0.0alpha7SVN.sql
postgis--2.0.0alpha2--2.0.0alpha7SVN.sql
postgis--2.0.0alpha3--2.0.0alpha7SVN.sql
postgis--2.0.0alpha4--2.0.0alpha7SVN.sql
postgis--2.0.0alpha5--2.0.0alpha7SVN.sql
postgis--2.0.0alpha6--2.0.0alpha7SVN.sql
postgis--2.0.0alpha7SVN.sql
postgis.control
postgis_topology--2.0.0alpha1--2.0.0alpha7SVN.sql
postgis_topology--2.0.0alpha2--2.0.0alpha7SVN.sql
postgis_topology--2.0.0alpha3--2.0.0alpha7SVN.sql
postgis_topology--2.0.0alpha4--2.0.0alpha7SVN.sql
postgis_topology--2.0.0alpha5--2.0.0alpha7SVN.sql
postgis_topology--2.0.0alpha6--2.0.0alpha7SVN.sql
postgis_topology--2.0.0alpha7SVN.sql
postgis_topology.control
postgis_topology--unpackaged--2.0.0alpha7SVN.sql


vim postgis.control
--------------------------------------
# postgis extension
comment = 'PostGIS geometry, geography, and raster spatial types and functions'
default_version = '2.0.0alpha7SVN'
module_pathname = '$libdir/postgis-2.0'
relocatable = true
--------------------------------------


-- Anzeige der installierten Erweiterungen
SELECT name, default_version, installed_version from pg_available_extensions
WHERE name like 'p%';

       name       | default_version | installed_version 
------------------+-----------------+-------------------
 postgis_topology | 2.0.0alpha7SVN  | 2.0.0alpha7SVN
 plpgsql          | 1.0             | 1.0
 postgis          | 2.0.0alpha7SVN  | 2.0.0alpha7SVN
(3 Zeilen)

-- oder Anzeige der installierten Erweiterungen
\dx
             Liste der installierten Erweiterungen
       Name       |    Version     |   Schema   | Beschreibung                             
------------------+----------------+------------+------------------
 plpgsql          | 1.0            | pg_catalog | PL/pgSQL procedural language
 postgis          | 2.0.0alpha7SVN | public     | PostGIS geometry, geography, a
nd raster spatial types and functions
 postgis_topology | 2.0.0alpha7SVN | topology   | PostGIS topology spatial types and functions
(3 Zeilen)




----------------------------------------------------------------------
-- 1.2 Typemod, View geometry_columns
----------------------------------------------------------------------
* Erzeugen Sie eine Tabelle poi mit Punkten in EPSG 25832 (gid serial, name varchar, the_geom POINT). Nutzen Sie typmod.
* Fügen Sie zwei Punkte in die Tabelle poi ein (352471/5530880 und 352543/5530746)
* Erstellen Sie eine Sicht v_poi_buffer, die die Flächen mit Puffer 100m um die Punkte enthält.
* Schauen Sie sich die Einträge in der Sicht geometry_columns an
* Schauen Sie sich die Tabellen mit QGIS an


-- Anlegen der Tabelle poi
CREATE TABLE poi (
gid serial,
name varchar,
the_geom geometry(POINT,25832)
);

-- Ausgabe der Tabellenstruktur
\d poi

-- Einfügen von Datensätzen in die Tabelle poi
INSERT INTO poi VALUES (1, 'Museum',ST_GeomFromText('POINT(352471 5530880)',25832));
INSERT INTO poi VALUES (2, 'Schwimmbad',ST_GeomFromText('POINT(352543 5530746)',25832));

-- Sicht mit Puffer und typemod erzeugen
CREATE VIEW v_buffer_poi as
SELECT gid,
name,
ST_Buffer(the_geom,100)::geometry(Polygon,25832) 
as the_geom
FROM poi;

-- Sicht mit Puffer, aber ohne typemod erzeugen
CREATE VIEW v_buffer_poi_ohne_typmod as
SELECT gid,
name,
ST_Buffer(the_geom,100)
as the_geom
FROM poi;

-- Anzeige der Sicht geometry_columns
SELECT f_table_schema,f_table_name,f_geometry_column,coord_dimension, srid, type 
FROM geometry_columns;

f_table_schema |f_table_name    |f_geometry_column|coord_dimension | srid |type   
---------------+-------------------+-------------+------------+-----+-------+-----
public         | poi                      | the_geom  | 2 | 25832 | POINT
public         | v_buffer_poi             | the_geom  | 2 | 25832 | POLYGON
public         | v_buffer_poi_ohne_typmod | the_geom  | 2 |     0 | GEOMETRY


-- Beispiel für nachträgliche Geometrietyp und srid-Zuweisung über ALTER COLUMN
ALTER TABLE puffer 
  ALTER COLUMN the_geom 
  SET DATA TYPE geometry(POLYGON,25832);


